=== debian/changelog ===
ceres-solver (1.1.1-1) unstable; urgency=low

  * Initial release (Closes: #673238)

 -- Koichi Akabe <vbkaisetsu@gmail.com>  Mon, 04 June 2012 07:15:43 +0900
