=== debian/control ===
Source: ceres-solver
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Koichi Akabe <vbkaisetsu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libgoogle-glog-dev (>= 0.3.1), libgflags-dev, libeigen3-dev, libsuitesparse-dev, libprotobuf-dev, protobuf-compiler
Standards-Version: 3.9.3
Section: math
Homepage: http://code.google.com/p/ceres-solver/
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/ceres-solver/trunk/
Vcs-Svn: svn://svn.debian.org/debian-science/packages/ceres-solver/trunk/

Package: libceres-dev
Section: libdevel
Architecture: any
Depends: libceres1 (= ${binary:Version}), ${misc:Depends}, libgoogle-glog-dev (>= 0.3.1), libeigen3-dev
Description: nonlinear least squares minimizer (development files)
 Ceres Solver solves nonlinear least squares problems comes up in
 a broad range of areas across science and engineering.
 .
 This package contains development header files.

Package: libceres1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: nonlinear least squares minimizer (shared library)
 Ceres Solver solves nonlinear least squares problems comes up in
 a broad range of areas across science and engineering.
 .
 This package contains development library.

Package: ceres-solver-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for ceres-solver
 Ceres Solver solves nonlinear least squares problems comes up in
 a broad range of areas across science and engineering.
 .
 This package contains tutorial and reference.
