=== debian/watch ===
version=3
http://code.google.com/p/ceres-solver/downloads/list?can=1 .*/ceres-solver-(\d[\d.]*)\.tar\.gz
