## ceres-solver 1.8.0

=== debian/changelog ===
ceres-solver (1.8.0-1+vivid1) vivid; urgency=medium

  * Initial release to vivid

 -- Michael Ferguson <mfergs7@gmail.com>  Fri, 12 Dec 2014 18:12:25 -0800
